// pages/vodTest/vodTest.js
const app = getApp();

const VOD = require("../../sdk/vod");
const GSSDK = require("../../sdk/gssdk");
const GS = GSSDK.GS;
var oldCurrentTime = -1;
Page({

    /**
    * 页面的初始数据
    */
    data: {
        array: ["leaveMessage", "submitVote", "playheadTime", "submitQAList", "submitChatHistory", "submitLeaveMessageList", "setupChatSync", "submitChatSegment", "uploadLogFile"],
        index: 0,//数组下标
        textValue: '',//输入框的值
        dataArray: [],//获取到的数据
        playSrc: '',//视频参数
        joinItem: '',//加入设置各种参数
        autoplay: true,
        showBar: false
    },

    /**
    * 生命周期函数--监听页面加载
    */
    onLoad: function (options) {
        this.channel = GS.createChannel();
        app.globalData.channel = this.channel;
        // 页面初始化 options为页面跳转所带来的参数
        if (options.item) {
            this.setData({
                joinItem: JSON.parse(options.item)
            });
        }
    },

    /**
    * 生命周期函数--监听页面初次渲染完成
    */
    onReady: function () {
        const that = this;
        this.videoContext = wx.createVideoContext('myVideo');

        const evts = ["onDocChange", "onDataReady", "onQAList", "onLottery",
            "onPause", "onPlay", "onStop", "onVote", "onStatus", "onAPIError", "onVideoUrl",
            "onAudioUrl", "onPlayheadTime", "onChatHistory", "onChatSegmentList", "onLeaveMessageList",
            "onAnno", "onChat", "onChapter", "onFileDuration", "onSeekCompleted",
            "onTitle", "loadStart"];

        for (var i = 0; i < evts.length; i++) {
            this.channel.bind(evts[i], function (e) {
                var dataArr = that.data.dataArray, obj = {};
                var date = new Date();
                var hours = date.getHours(), minutes = date.getMinutes(), seconds = date.getSeconds();

                obj.time = that.numTen(hours) + ":" + that.numTen(minutes) + ":" + that.numTen(seconds);
                obj.name = e.type + ":";
                obj.data = JSON.stringify(e.data);

                dataArr.unshift(obj);
                if (e.type == "onVideoUrl") {
                    that.setData({
                        playSrc: e.data.mediaUrl,
                        dataArray: dataArr
                    });
                } else {
                    that.setData({
                        dataArray: dataArr
                    });
                }
            });
        }

        this.numTen = function (m) {
            return m > 9 ? m : '0' + m;
        }

        this.channel.bind("onDataReady", function () {
            that.videoContext.play();
        })




        VOD._open_.init({
            "widget": this.channel,
            "site": that.data.joinItem.site,
            "ownerid": that.data.joinItem.id,
            "ctx": that.data.joinItem.ctx,
            "authcode": that.data.joinItem.authcode,
            "uid": '',
            "uname": app.globalData.userInfo.nickName,
            "encodetype": '',
            "password": '',
            "k": that.data.joinItem.k,
            "istest": 'true'
        }, function (e) {
            console.log("回调");
            app.globalData.userInfo.userid = e.userid;
        });


        // var t = 0;
        // setTimeout(res=>{
        //     VOD.initMediaEvent.play();
        //     VOD.initMediaEvent.playing();
        //     var timerun = setInterval(function(){
        //         app.globalData.currentTime = t;
        //         t++;
        //         if(t>150){clearInterval(timerun)}
        //     }, 150);
        // }, 2000)
    },
    pickerChange: function (e) {
        this.setData({
            index: e.detail.value
        })
    },
    sendMes: function (e) {
        var that = this, arr = this.data.array, index = this.data.index, val = this.data.textValue, dataArr = this.data.dataArray, obj = {};
        if (val == '') return false;
        var date = new Date();
        var hours = date.getHours(), minutes = date.getMinutes(), seconds = date.getSeconds();

        obj.time = that.numTen(hours) + ":" + that.numTen(minutes) + ":" + that.numTen(seconds);
        obj.name = arr[index] + ":";
        obj.data = val;

        this.channel.send(arr[index], JSON.parse(val));
        dataArr.unshift(obj);
        that.setData({
            dataArray: dataArr
        });
    },
    textareaValue: function (e) {
        var val = e.detail.value;
        this.setData({
            textValue: val
        })
    },
    timeupdate: function (event) {
        if (event.detail.currentTime != oldCurrentTime) {
            app.globalData.currentTime = event.detail.currentTime;
            VOD.initMediaEvent.timeRecord();
            if (Math.abs(event.detail.currentTime - oldCurrentTime) > 1) {
                VOD.initMediaEvent.timeupdate();
                VOD.initMediaEvent.seeking();
                VOD.initMediaEvent.seeked();
            }
            oldCurrentTime = event.detail.currentTime;
            console.log(app.globalData.currentTime);
        }
    },
    playVideo: function (e) {
        VOD.initMediaEvent.play();
        VOD.initMediaEvent.playing();
    },
    pauseVideo: function (e) {
        VOD.initMediaEvent.pause();
    },
    endVideo: function (e) {
        VOD.initMediaEvent.ended();
    },
    /**
    * 生命周期函数--监听页面卸载
    */
    onUnload: function (res) {
        VOD._open_.refresh();
    }
})